'use strict';

var _package = require('../package.json');

var _server = require('./server');

var _server2 = _interopRequireDefault(_server);

var _zmq = require('./zmq');

var _zmq2 = _interopRequireDefault(_zmq);

var _store = require('./redux/store');

var _store2 = _interopRequireDefault(_store);

var _appInfo = require('./redux/modules/appInfo');

var appInfo = _interopRequireWildcard(_appInfo);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// // import Rx from 'rxjs';

var url = process.env.ZMQ_URL || 'tcp://localhost:5001';
var subscription = process.env.ZMQ_SUBSCRIPTION || '';

_zmq2.default.connect(url);
console.log('ZMQ connected to ' + url + ' sub=\'' + subscription + '\'');
_zmq2.default.subscribe(subscription);

_store2.default.dispatch(appInfo.onStart({ name: _package.name, version: _package.version }));

process.on('SIGINT', function () {
    console.log();
    console.log("Exiting ...");
    _zmq2.default.unsubscribe(subscription);
    _zmq2.default.disconnect(url);
    process.exit(1);
});