'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = reducer;
exports.getState = getState;
exports.getWs = getWs;
var ON_APP_START = exports.ON_APP_START = 'ON_APP_START';
var ON_WS_ENTER = exports.ON_WS_ENTER = 'ON_WS_ENTER';
var ON_WS_EXIT = exports.ON_WS_EXIT = 'ON_WS_EXIT';

// actions
var onStart = exports.onStart = function onStart(data) {
    return {
        type: ON_APP_START,
        payload: data
    };
};

var wsEnter = exports.wsEnter = function wsEnter() {
    return {
        type: ON_WS_ENTER
    };
};

var wsExit = exports.wsExit = function wsExit() {
    return {
        type: ON_WS_EXIT
    };
};

var initialState = {
    nclients: 0
};

// reducer
function reducer() {
    var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
    var action = arguments[1];

    switch (action.type) {
        case ON_APP_START:
            var _action$payload = action.payload,
                name = _action$payload.name,
                version = _action$payload.version;

            console.log('Starting \'' + name + ' ' + version + '\' ...');
            return _extends({}, state, { name: name, version: version });
        case ON_WS_ENTER:
            return _extends({}, state, { nclients: state.nclients + 1 });
        case ON_WS_EXIT:
            return _extends({}, state, { nclients: state.nclients - 1 });
        default:
            return state;
    }
}

// selectors 
function getState(store) {
    return store.getState().appInfo;
}

function getWs(store) {
    return JSON.stringify({
        type: "app",
        payload: getState(store)
    });
}