'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _redux = require('redux');

var _reduxCliLogger = require('redux-cli-logger');

var _reduxCliLogger2 = _interopRequireDefault(_reduxCliLogger);

var _appInfo = require('./modules/appInfo');

var _appInfo2 = _interopRequireDefault(_appInfo);

var _ctp3Mon = require('./modules/ctp3Mon');

var _ctp3Mon2 = _interopRequireDefault(_ctp3Mon);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var reducer = (0, _redux.combineReducers)({
    appInfo: _appInfo2.default,
    ctp3Mon: _ctp3Mon2.default
});

var middleware = [
    // your middleware here
];

if (process.env.NODE_ENV === 'development') {
    var loggerOptions = {};
    var logger = (0, _reduxCliLogger2.default)(loggerOptions);
    middleware.push(logger);
}

var enhancer = (0, _redux.compose)(_redux.applyMiddleware.apply(undefined, middleware)
// optionally, electron-enhancer, redux-loop, etc.
);

var configureStore = function configureStore(initialState) {
    return (0, _redux.createStore)(reducer, initialState, enhancer);
};

var store = configureStore();
exports.default = store;