'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _zeromq = require('zeromq');

var _zeromq2 = _interopRequireDefault(_zeromq);

var _rxjs = require('rxjs');

var _rxjs2 = _interopRequireDefault(_rxjs);

var _server = require('./server');

var _server2 = _interopRequireDefault(_server);

var _store = require('./redux/store');

var _store2 = _interopRequireDefault(_store);

var _ctp3Mon = require('./redux/modules/ctp3Mon');

var ctp3Mon = _interopRequireWildcard(_ctp3Mon);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var sub;
var zmq_sock = _zeromq2.default.socket('sub');

var zmq$ = {};

zmq_sock.on('message', function (topic, msg) {
    // console.log(topic.toString(), msg.toString());
    var topicStr = topic.toString();
    if (!ctp3Mon.getState(_store2.default).availMonGroups.includes(topicStr)) {
        _store2.default.dispatch(ctp3Mon.ctp3ZmqSubAdd(topic.toString()));
        _server2.default.wss.broadcast(ctp3Mon.getWsAvailGroups(_store2.default));
        zmq$[topicStr] = new _rxjs2.default.ReplaySubject(process.env.ZMQ_CACHE || 1);
    }

    try {
        var payload = JSON.parse(msg.toString());
        var type = payload.type,
            data = payload.data;

        if (zmq$[topicStr] === undefined) return;
        zmq$[topicStr].next({
            type: type,
            data: data
        });
    } catch (e) {
        console.log("Msg: '" + msg.toString() + "' was not able to parse to JSON");
    }
});

zmq_sock.zmq$ = zmq$;

exports.default = zmq_sock;